[build-system]
requires = ["pdm-backend"]
build-backend = "pdm.backend"

[project]
name = "{{project_name}}"
version = "0.0.0"
description = "{{short_description}}"
license = {file = "LICENSE"}
authors = [{name = "{{author_name}}", email= "{{author_email}}"}]
readme = "README.md"
requires-python = ">=3.9"
dependencies = [
    "typer"
]

[project.scripts]
{{project_name}} = "{{project_name}}.cli:main"

## PDM CONFIG
[tool.pdm.dev-dependencies]
dev = [
    "bandit",
    "build",
    "pre-commit",
    "pyright",
    "towncrier",
    "ruff",
]
test = [
    "pytest",
    "pytest-cov",
]
doc = [
    "mkdocs",
    "mkdocs-material",
    "mkdocstrings",
]

## PDM SCRIPT DEFINITIONS
[tool.pdm.scripts.bandit]
cmd = "bandit -r src -ll"

[tool.pdm.scripts.type_check]
cmd = "pyright"

[tool.pdm.scripts.ruff_check]
cmd = "ruff check . --fix"

[tool.pdm.scripts.ruff_format]
cmd = "ruff format ."

[tool.pdm.scripts.lint]
composite = [
    "bandit",
    "type_check",
    "ruff_check",
    "ruff_format",
]

[tool.pdm.scripts.test]
cmd = "pytest"

[tool.pdm.scripts.check]
composite = [
    "lint",
    "test",
]

[tool.pdm.scripts.news_add]
cmd = "towncrier create -c {args}"

[tool.pdm.scripts.get_version]
shell = "grep -m 1 'version =' pyproject.toml | cut -d '\"' -f2"

[tool.pdm.scripts.changelog_update]
shell = "pdm run towncrier build --keep --version \"$(pdm get_version)\""

[tool.pdm.scripts.remove_news]
shell = "git rm -f changelog.d/*.md"

[tool.pdm.scripts.update_version]
composite = [
    "pdm bump {args}",
    "pdm changelog_update",
    "pdm remove_news",
] 

[tool.pdm.scripts.git_add]
shell = "git add ."

[tool.pdm.scripts.git_commit]
shell = "git commit"

[tool.pdm.scripts.git_push]
shell = "git push origin {args}"

[tool.pdm.scripts.release]
composite = [
    "update_version {args}",
    "git_add",
    "git_commit",
    "pdm bump tag",
    "git_push main --tags",
]

## BUILD SYSTEM CONFIG
[tool.pdm.build]
includes = ["src/data"]

## PYRIGHT CONFIG
[tool.pyright]
include = [
    "src",
    "tests",
]
exclude = ["**/node_modules",
    "**/__pycache__",
]

reportMissingImports = true
reportMissingTypeStubs = false


## PYTEST CONFIG
[tool.pytest.ini_options]
testpaths = [
    "tests",
]

## RUFF CONFIG
[tool.ruff]
# Same as Black.
line-length = 88
indent-width = 4

# Assume Python 3.9
target-version = "py39"

[tool.ruff.lint]
# Enable Pyflakes (`F`) and a subset of the pycodestyle (`E`)  codes by default.
# Unlike Flake8, Ruff doesn't enable pycodestyle warnings (`W`) or
# McCabe complexity (`C901`) by default.
select = ["E4", "E7", "E9", "F"]
ignore = []

# Allow fix for all enabled rules (when `--fix`) is provided.
fixable = ["ALL"]
unfixable = []

# Allow unused variables when underscore-prefixed.
dummy-variable-rgx = "^(_+|(_+[a-zA-Z0-9_]*[a-zA-Z0-9]+?))$"

[tool.ruff.format]
# Like Black, use double quotes for strings.
quote-style = "double"

# Like Black, indent with spaces, rather than tabs.
indent-style = "space"

# Like Black, respect magic trailing commas.
skip-magic-trailing-comma = false

# Like Black, automatically detect the appropriate line ending.
line-ending = "auto"

## TOWNCRIER CONFIG
[tool.towncrier]
directory = "changelog.d"
filename = "CHANGELOG.md"
start_string = "<!-- towncrier release notes start -->\n"
underlines = ["", "", ""]
title_format = "## [{version}](https://gitlab.com/{{remote_repo_relative_path}}/-/tree/v{version}) - {project_date}"
issue_format = "[#{issue}](https://gitlab.com/{{remote_repo_relative_path}}/-/issues/{issue})"

[[tool.towncrier.type]]
directory = "security"
name = "Security"
showcontent = true

[[tool.towncrier.type]]
directory = "removed"
name = "Removed"
showcontent = true

[[tool.towncrier.type]]
directory = "deprecated"
name = "Deprecated"
showcontent = true

[[tool.towncrier.type]]
directory = "added"
name = "Added"
showcontent = true

[[tool.towncrier.type]]
directory = "changed"
name = "Changed"
showcontent = true

[[tool.towncrier.type]]
directory = "fixed"
name = "Fixed"
showcontent = true
